// MY_MOUSE.HPP - U.V.Ivanov, A.A.Shabarshin  25.05.1997
// Ported to WATCOM-C/C++ from U_MOUSE.H      18.01.1998
// This code is PUBLIC DOMAIN - use it on your own RISK!

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <graph.h>
#include <dos.h>
#ifndef __MY_MOUSE_H
#define __MY_MOUSE_H

#define U_LEFT        0
#define U_RIGHT       1
#define U_MIDDLE      2
#define U_HARD_CURSOR 1
#define U_SOFT_CURSOR 0
#define U_GRAPH       0
#define U_TEXT        1

class Mouse {
      short x,y;
      short left,middle,right;
      short mode;
      short fshow;
public:
      void Sensitive(short,short);
      void DoubleSpeed(short);
      void Limited(short,short,short,short);
      void GraphMask(short*,short,short);
      void TextMask(short,short,short);
      void Move(short,short);
      void Show(void);
      void Hide(void);
      void Position(void);
      short DoublePress(short);
      short DoubleLeave(short);
      short GetButton(short);
      short GetMode(void){return mode;};
      short GetX(void){return x;};
      short GetY(void){return y;};
      void SetMode(short);
      Mouse(short t); // U_GRAPH or U_TEXT
      void Wait(short i);
};

void Mouse::Wait(short i)
{   while(GetButton(i)) Position();
}

Mouse::Mouse(short a)
{
 union REGS inregs, outregs;
 inregs.w.ax = 0;
 int386 (0x33, &inregs, &outregs);
 if(outregs.w.ax==0)
 {
  puts("Mouse not installed !");
  exit(-1);
 }

 left=right=middle=0;
 mode=a;
 fshow=0;
 switch(a)
 {
   case U_GRAPH: { videoconfig vc;
                   _getvideoconfig(&vc);
                   Limited(0,0,vc.numxpixels-1,vc.numypixels-1);
                   Sensitive(0x000f,0x000f);
                   DoubleSpeed(1);
                   break;
                 }
   case  U_TEXT: { TextMask(U_HARD_CURSOR,0,7);
                   Limited(0,0,639,199);
                   Sensitive(0x000f,0x000f);
                   DoubleSpeed(1);
                   break;
                 }
  }
}

void Mouse::Show()
{
 if(!fshow)
 {  fshow=1;
    union REGS inregs, outregs;
    inregs.w.ax = 0x1;
    int386 (0x33, &inregs, &outregs);
 }
}

void Mouse::Hide()
{
 if(fshow)
 {  fshow=0;
    union REGS u_in,u_out;
    u_in.w.ax=0x0002;
    int386(0x33,&u_in,&u_out);
 }
}

void Mouse::Position()
{
 left=middle=right=0;

 union REGS u_in,u_out;
 u_in.w.ax=0x0003;
 int386(0x33,&u_in,&u_out);

 if(u_out.w.bx==0x0001) left=1;
 if(u_out.w.bx==0x0004) middle=1;
 if(u_out.w.bx==0x0002) right=1;
 if(u_out.w.bx==0x0003) {left=right=1;}
 if(u_out.w.bx==0x0005) {middle=left=1;}
 if(u_out.w.bx==0x0006) {middle=right=1;}
 if(u_out.w.bx==0x0007) {left=middle=right=1;}

 switch(mode)
  {
   case U_GRAPH: { x=u_out.w.cx;
                   y=u_out.w.dx;
                   break;
                 }
   case U_TEXT:  { x=(u_out.w.cx)/8;
                   y=(u_out.w.dx)/8;
                   break;
                 }
  }
}

void Mouse::Move(short a,short b)
{
 union REGS u_in,u_out;
 u_in.w.ax=0x0004;
 switch(mode)
  {
   case U_GRAPH: { u_in.w.cx=a;
                   u_in.w.dx=b;
                   break;
                 }
   case  U_TEXT: { u_in.w.cx=a*8;
                   u_in.w.dx=b*8;
                   break;
                 }
  }
 int386(0x33,&u_in,&u_out);
}

void Mouse::GraphMask(short *a,short b,short c)
{
 union REGS inregs, outregs;
 struct SREGS sregs;
 inregs.w.ax = 0x9;
 inregs.w.bx = b;
 inregs.w.cx = c;
 inregs.x.edx = FP_OFF (a);
 sregs.es = FP_SEG (a);
 int386x (0x33, &inregs, &outregs, &sregs);
}

void Mouse::TextMask(short a,short b,short c)
{
 union REGS u_in,u_out;
 u_in.w.ax=0x000a;
 u_in.w.bx=a;
 u_in.w.cx=b;
 u_in.w.dx=c;
 int386(0x33,&u_in,&u_out);
}

void Mouse::Limited(short a,short b,short c,short d)
{
 union REGS u_in,u_out;
 u_in.w.ax=0x0007;
 switch(mode)
  {
   case U_GRAPH: { u_in.w.cx=a;
                   u_in.w.dx=c;
                   break;
                 }
   case  U_TEXT: { u_in.w.cx=a*8;
                   u_in.w.dx=c*8;
                   break;
                 }
  }
 int386(0x33,&u_in,&u_out);
 u_in.w.ax=0x0008;
 switch(mode)
  {
   case U_GRAPH:{ u_in.w.cx=b;
                  u_in.w.dx=d;
                  break;
                }
   case U_TEXT: { u_in.w.cx=b*8;
                  u_in.w.dx=d*8;
                  break;
                }
  }
 int386(0x33,&u_in,&u_out);
}

void Mouse::DoubleSpeed(short a)
{
 union REGS u_in,u_out;
 u_in.w.ax=0x0013;
 u_in.w.dx=a;
 int386(0x33,&u_in,&u_out);
}

void Mouse::Sensitive(short a,short b)
{
 union REGS u_in,u_out;
 u_in.w.ax=0x000f;
 u_in.w.cx=a;
 u_in.w.dx=b;
 int386(0x33,&u_in,&u_out);
}

short Mouse::DoublePress(short a)
{
 union REGS u_in,u_out;
 int num=0;
 u_in.w.ax=0x0005;
 u_in.w.bx=a;
 int386(0x33,&u_in,&u_out);
 if(u_out.w.bx==1)
  {
   num=1;

   switch(mode)
    {
     case U_GRAPH: { x=u_out.w.cx;
                     y=u_out.w.dx;
                     break;
                   }
     case  U_TEXT: { x=u_out.w.cx/8;
                     y=u_out.w.dx/8;
                     break;
                   }
    }
   delay(200);
   u_in.w.ax=0x0005;
   u_in.w.bx=a;
   int386(0x33,&u_in,&u_out);
   if(u_out.w.bx==1)
    {
     num=2;
     switch(mode)
      {
       case U_GRAPH: { x=u_out.w.cx;
                       y=u_out.w.dx;
                       break;
                     }
       case U_TEXT:  { x=u_out.w.cx/8;
                       y=u_out.w.dx/8;
                       break;
                     }
      }
    }
  }
 return num;
}

short Mouse::DoubleLeave(short a)
{
 union REGS u_in,u_out;
 int num=0;
 u_in.w.ax=0x0006;
 u_in.w.bx=a;
 int386(0x33,&u_in,&u_out);
 if(u_out.w.bx==1)
  {
   num=1;

   switch(mode)
    {
     case U_GRAPH: { x=u_out.w.cx;
                     y=u_out.w.dx;
                     break;
                   }
     case U_TEXT:  { x=u_out.w.cx/8;
                     y=u_out.w.dx/8;
                     break;
                   }
    }
   delay(200);
   u_in.w.ax=0x0006;
   u_in.w.bx=a;
   int386(0x33,&u_in,&u_out);
   if(u_out.w.bx==1)
    {
     num=2;
     switch(mode)
      {
       case U_GRAPH: { x=u_out.w.cx;
                       y=u_out.w.dx;
                       break;
                     }
       case  U_TEXT: { x=u_out.w.cx/8;
                       y=u_out.w.dx/8;
                       break;
                     }
      }
    }
  }
 return num;
}

short Mouse::GetButton(short a)
{ switch(a)
  { case U_LEFT: return left;
    case U_RIGHT: return right;
    case U_MIDDLE: return middle;
  }
  return -1;
}

#endif
